<template>
<el-container>
	<el-header>
		<div class="left-panel">
			<el-input v-model="search.keyword" placeholder="关键词" style="width:150px; margin-right: 10px;" clearable></el-input>
			<el-button-group style="margin-left: 10px;">
				<el-button type="primary" icon="el-icon-search" @click="upsearch">搜索</el-button>
			</el-button-group>
		</div>
		<div class="right-panel">
			<el-button-group>
				<el-button type="danger" icon="el-icon-plus" @click="add">添加</el-button>
			</el-button-group>
		</div>
	</el-header>
	<el-main class="nopadding">
		<scTable tableName="member" ref="table" :apiObj="list.apiObj" :column="list.column" row-key="id" @selection-change="selectionChange" border stripe>
			<el-table-column type="selection" width="50"></el-table-column>
			<template #order_no="scope">
				{{ scope.row.order?.order_no }}
			</template>
			<template #member="scope">
				{{ scope.row.member?.nickname }}（{{ scope.row.member?.username }}）
			</template>
			<template #status="scope">
				<el-tag :type="status[scope.row.status]?.type">{{ status[scope.row.status]?.label ?? '未知'}}</el-tag>
			</template>
			<el-table-column label="操作" fixed="right" align="center" width="140">
				<template #default="scope">
					<el-button-group>
						<el-button type="primary" @click="table_audit(scope.row, scope.$index)" v-if="scope.row.status == 0">审核</el-button>
					</el-button-group>
				</template>
			</el-table-column>
		</scTable>
	</el-main>
	<save v-if="dialog.save" ref="saveBox" @success="upsearch" @closed="dialog.save=false" />
</el-container>
</template>

<script>
import save from './save.vue'

export default{
	name: 'order.refund',
	components:{
		save,
	},
	data(){
		return {
			dialog: {search: false, import: false, print: false},
			status: {0: {label: '待审核', type: 'primary'}, 1: {label: '已通过', type: 'success'}, 2: {label: '已拒绝', type: 'danger'}, 3: {label: '已完成', type: 'warning'}},
			list: {
				apiObj: this.$API.order.refund.list,
				column: [
					{prop: 'id', label: 'ID', width: 80},
					{prop: 'order_id', label: '订单ID', width: 120},
					{prop: 'order_no', label: '订单号', width: 240},
					{prop: 'member', label: '申请人'},
					{prop: 'amount', label: '退款金额', width: 120},
					{prop: 'reason', label: '退款原因', width: 120},
					{prop: 'status', label: '退款状态', width: 120},
					{prop: 'created_at', label: '添加时间', width: 140},
					{prop: 'updated_at', label: '更新时间', width: 140},
				],
			},
			selection: [],
			search: {},
		}
	},
	methods:{
		upsearch(){
			this.$refs.table.reload(this.search);
		},
		moreUpsearch(search){
			this.search = search;
			this.upsearch();
		},
		moreSearch(){
			this.dialog.search = true
			this.$nextTick(() => {
				this.$refs.searchBox.open().setData(this.search)
			})
		},
		//表格选择后回调事件
		selectionChange(selection){
			this.selection = selection;
		},
		batch_del(){

		},
		table_show(row){
			this.dialog.detail = true
			this.$nextTick(() => {
				this.$refs.detailBox.open().setData(row)
			})
		},
		add(){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveBox.open()
			})
		},
		table_edit(row){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveBox.open('edit').setData(row)
			})
		},
		table_audit(row){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveBox.open('audit').setData(row)
			})
		},
		async table_del(row){
			var reqData = {id: row.id}
			var res = await this.$API.order.refund.delete.post(reqData);
			if(res.code == 1){
				//这里选择刷新整个表格 OR 插入/编辑现有表格数据
				this.upsearch()
				this.$message.success("删除成功")
			}else{
				this.$alert(res.message, "提示", {type: 'error'})
			}
		}
	}
}
</script>
